searchNodes=[{"doc":"Virtual JOSE HSM for signing JWSes and decrypting JWEsIt is a virtual HSM in the sense that keys private keys for signing and decrypting are not available to other processes, and are particularly protected against leaking:there are stored in a private ETSprocesses dealing with these keys are marked as sensitivekeys loaded from the disk or the environment can be deleted after loading (ideal for container deployment)Other features include:keys can be generated automatically given a specification, so that there no secret to handle during deploymentit is automatically clusterized: any node can sign a JWS or decrypt a JWE with any key in the cluster. Nodes don't share keys (they can't) but can work with each other in a transparent fashionkey ID is automatically generated using RFC7638 - JSON Web Key (JWK) Thumbprinthowever, note that due to a limitation in the underlying JOSE library, JWSes do not include the kid in their headerLaunching JOSEVirtualHSMJOSEVirtualHSM is a GenServer that must be launched in a supervised manner at application startup. In your app/application.ex file, add:children = [ JOSEVirtualHSM ]orchildren = [ {JOSEVirtualHSM, opts...} ]where opts is a Keyword to the list of children.Options:delete_on_load: when loading a private key from a file or the environment, this options, when set to true, deletes the key after loading. Defaults to true:keys: the list of keys to load. See key_load_specs/0 for the different methods to load keysEnvironment optionsThe key specification can also be retrieved from the environment options:config/config.exsconfig :jose_virtual_hsm, :keys, [ {:auto_gen, {:ec, &quot;P-256&quot;}, %{&quot;use&quot; =&gt; &quot;sig&quot;}}, {:auto_gen, {:rsa, 2048}, %{&quot;use&quot; =&gt; &quot;sig&quot;}}, {:auto_gen, {:okp, :Ed25519}, %{&quot;use&quot; =&gt; &quot;sig&quot;}}, {:auto_gen, {:ec, &quot;P-256&quot;}, %{&quot;use&quot; =&gt; &quot;enc&quot;}}, {:auto_gen, {:rsa, 2048}, %{&quot;use&quot; =&gt; &quot;enc&quot;}}, {:auto_gen, {:okp, :X25519}, %{&quot;use&quot; =&gt; &quot;enc&quot;}} ]This key specification is used in the following examples.ExampleRetrieving public keysiex&gt; JOSEVirtualHSM.public_keys() [ %{ &quot;crv&quot; =&gt; &quot;X25519&quot;, &quot;kid&quot; =&gt; &quot;NqYw6_wlorTvDqae3HaI79i_k_Q61l0jESQNvgT0Ku4&quot;, &quot;kty&quot; =&gt; &quot;OKP&quot;, &quot;use&quot; =&gt; &quot;enc&quot;, &quot;x&quot; =&gt; &quot;lY2nopV03NTsSqCVgfyr_VNjTBkUhGHcHjIHJNrlaKQ&quot; }, %{ &quot;crv&quot; =&gt; &quot;Ed25519&quot;, &quot;kid&quot; =&gt; &quot;Hq3_i8UWJ1FqokUqTQRDLw4GvvBQCKiMjSoQ4Ng6CY0&quot;, &quot;kty&quot; =&gt; &quot;OKP&quot;, &quot;use&quot; =&gt; &quot;sig&quot;, &quot;x&quot; =&gt; &quot;XxHceRoVym7hsb5W-T2RqTzgoz_DEmCZKHBjy6MWsZA&quot; }, %{ &quot;e&quot; =&gt; &quot;AQAB&quot;, &quot;kid&quot; =&gt; &quot;5A5Z3JxpYNO4pqbfC4wSFUk2cpkcAxwZsH0yev3zXpk&quot;, &quot;kty&quot; =&gt; &quot;RSA&quot;, &quot;n&quot; =&gt; &quot;7Rwb2l4ORycxCPAMK2B_p1FqKqrBpmcjklqazucAiJtNPtY2n-yEziD05-urwutIN2-wfaKIGg51-8KIQN5x_PTXUxje2oK3GOHHWaSWGpd1kJVEe-owSKGQxoga5rQDTk4j3MMA0brbgoJM2v32lKiv5CgV6E-wgCXb8QlrvIpwhnIN9CPEHuxo9Izpw8WqIj4d8Uu7LohxUM0eFfBkdbmgt5xL4Xm5MV6eDRhYq9agRLGNbBIHK2T5Xyq6-YB5URtWCeizA8hongk6nZAzy19wvz88pj4CsBy73UuP0jdT-wlGGvTpGx9AEFLv1p_RXzVgfZMGn2z3Q8Mhf0mxVQ&quot;, &quot;use&quot; =&gt; &quot;sig&quot; }, %{ &quot;e&quot; =&gt; &quot;AQAB&quot;, &quot;kid&quot; =&gt; &quot;szhiyrpeKBtQOr6cSEj3TbJ87vqvvGuk3Is6cPBYNm0&quot;, &quot;kty&quot; =&gt; &quot;RSA&quot;, &quot;n&quot; =&gt; &quot;5GX4GERxJ2rV-w5T2G00D3-HLEriXjriL-w7TkCB9H8zhiljHH0SxmbxBMT5HksJMWQyiDZEKp6ilrZCjsvOAJCpvh0SrPnIRzu95Wt1VlGOlp0C2BnL0wuPnkrUHbGZAzE-ux4ISpw9LqTi6KlL1dWQei6-_ihs0E37iTpFJy2EbEVXG6ydsH0FnoJv0_dgf3P4Yy8kIoNx5f4czLSWhK-psoPVKxxAN3mlY7iRGQHxOdgEyrsANj8uSQehzO87T5IVmMDtoBBx6PUn9awDW5emoU_mfXy3hlR3S67pjbjfNA5A3QZBs39-hCU92EtA7CS0IQ_rvvAfvlLV3T-tjQ&quot;, &quot;use&quot; =&gt; &quot;enc&quot; }, %{ &quot;crv&quot; =&gt; &quot;P-256&quot;, &quot;kid&quot; =&gt; &quot;ltu_BZFFssJhqlTdKvf3VWu7z9dFKhwFxXSx8Q-bpw4&quot;, &quot;kty&quot; =&gt; &quot;EC&quot;, &quot;use&quot; =&gt; &quot;enc&quot;, &quot;x&quot; =&gt; &quot;jopq4PgS4w9721MwJppxw7niV-1zqgtBd-JeVWPuBcU&quot;, &quot;y&quot; =&gt; &quot;Eo1xbm0g5AsB8GSiXKHRynXH2OwRcMO9i-6PTi-k-GE&quot; }, %{ &quot;crv&quot; =&gt; &quot;P-256&quot;, &quot;kid&quot; =&gt; &quot;SiuAFPXstUhUzhmc__1mybX1ZJcJ6F2llEeb-LaAjIo&quot;, &quot;kty&quot; =&gt; &quot;EC&quot;, &quot;use&quot; =&gt; &quot;sig&quot;, &quot;x&quot; =&gt; &quot;2PXy4aIbWUHzkRksSITO1ws9Y1AI14fBAtsvr1UDwXQ&quot;, &quot;y&quot; =&gt; &quot;hPtgSkKH6DXzh18Ym_jh9bzcJir5mKp_skj9oKI5ydA&quot; } ]These public keys can obviously be shared with third parties. They can be used:to verify signature of a JWS signed by JOSEVirtualHSMto encrypt a JWE to be sent to the server using JOSEVirtualHSMJOSEVirtualHSM doesn't support JWS verification and JWE encryption. For that, use JOSE or JOSEUtils instead.Signing:iex&gt; JOSEVirtualHSM.sign(%{&quot;hello&quot; =&gt; &quot;world&quot;}) {:ok, {&quot;eyJhbGciOiJSUzI1NiJ9.eyJoZWxsbyI6IndvcmxkIn0.nFP2GBJdsKzgUMR7g55pMmtNckXB9F9C83jhfAW0qOake7AmpZb3eLZhGi3OrTB7CRI2x9MHtA1qQMdOY0u8R_VovYfv5fGLVRJLe8uICGIq1NojO_66lMMoxmtMxIhVcX1FZfWR9Z_Ez4KGVm4eJvTuO33ds115Ik8Vh3aGFBorW74rYqjYZPgEHyjO4RqbzexBodq-z5rGOqAvFgz9C6X_xkMwiI6mNI4XIQ-5jzLPKMP5t94QwJGZ4EEc9QyFbNqmh2OlUaY0NTthP6MAzler7K5oz2S_6mQvt6K4Fmk1C-HIR3nad_s_z-PLvj6tEJnmIiEcFHTxfRcceUQ_QA&quot;, %{ &quot;e&quot; =&gt; &quot;AQAB&quot;, &quot;kid&quot; =&gt; &quot;5A5Z3JxpYNO4pqbfC4wSFUk2cpkcAxwZsH0yev3zXpk&quot;, &quot;kty&quot; =&gt; &quot;RSA&quot;, &quot;n&quot; =&gt; &quot;7Rwb2l4ORycxCPAMK2B_p1FqKqrBpmcjklqazucAiJtNPtY2n-yEziD05-urwutIN2-wfaKIGg51-8KIQN5x_PTXUxje2oK3GOHHWaSWGpd1kJVEe-owSKGQxoga5rQDTk4j3MMA0brbgoJM2v32lKiv5CgV6E-wgCXb8QlrvIpwhnIN9CPEHuxo9Izpw8WqIj4d8Uu7LohxUM0eFfBkdbmgt5xL4Xm5MV6eDRhYq9agRLGNbBIHK2T5Xyq6-YB5URtWCeizA8hongk6nZAzy19wvz88pj4CsBy73UuP0jdT-wlGGvTpGx9AEFLv1p_RXzVgfZMGn2z3Q8Mhf0mxVQ&quot;, &quot;use&quot; =&gt; &quot;sig&quot; }}} iex&gt; JOSEVirtualHSM.sign(%{&quot;hello&quot; =&gt; &quot;world&quot;}) {:ok, {&quot;eyJhbGciOiJFZERTQSJ9.eyJoZWxsbyI6IndvcmxkIn0.WVRgyl4Pen0nieJF7cmGXQnkOocP4B6i78VgkKxcu_-gADSIM5Cg_mL2T-cU1ZY1ib91bQnHALdNoXqVSi66DQ&quot;, %{ &quot;crv&quot; =&gt; &quot;Ed25519&quot;, &quot;kid&quot; =&gt; &quot;Hq3_i8UWJ1FqokUqTQRDLw4GvvBQCKiMjSoQ4Ng6CY0&quot;, &quot;kty&quot; =&gt; &quot;OKP&quot;, &quot;use&quot; =&gt; &quot;sig&quot;, &quot;x&quot; =&gt; &quot;XxHceRoVym7hsb5W-T2RqTzgoz_DEmCZKHBjy6MWsZA&quot; }}} iex&gt; JOSEVirtualHSM.sign(%{&quot;hello&quot; =&gt; &quot;world&quot;}) {:ok, {&quot;eyJhbGciOiJFZERTQSJ9.eyJoZWxsbyI6IndvcmxkIn0.WVRgyl4Pen0nieJF7cmGXQnkOocP4B6i78VgkKxcu_-gADSIM5Cg_mL2T-cU1ZY1ib91bQnHALdNoXqVSi66DQ&quot;, %{ &quot;crv&quot; =&gt; &quot;Ed25519&quot;, &quot;kid&quot; =&gt; &quot;Hq3_i8UWJ1FqokUqTQRDLw4GvvBQCKiMjSoQ4Ng6CY0&quot;, &quot;kty&quot; =&gt; &quot;OKP&quot;, &quot;use&quot; =&gt; &quot;sig&quot;, &quot;x&quot; =&gt; &quot;XxHceRoVym7hsb5W-T2RqTzgoz_DEmCZKHBjy6MWsZA&quot; }}} iex&gt; JOSEVirtualHSM.sign(%{&quot;hello&quot; =&gt; &quot;world&quot;}) {:ok, {&quot;eyJhbGciOiJFUzI1NiJ9.eyJoZWxsbyI6IndvcmxkIn0.1viHUsVOseF1eJ0nZAOXbo0RfHGP5H1U8lfV9qLijf4EnDbaPI7NkRdFQIHvbYVTYakm0dHdF2YPlNfKOrGMbg&quot;, %{ &quot;crv&quot; =&gt; &quot;P-256&quot;, &quot;kid&quot; =&gt; &quot;SiuAFPXstUhUzhmc__1mybX1ZJcJ6F2llEeb-LaAjIo&quot;, &quot;kty&quot; =&gt; &quot;EC&quot;, &quot;use&quot; =&gt; &quot;sig&quot;, &quot;x&quot; =&gt; &quot;2PXy4aIbWUHzkRksSITO1ws9Y1AI14fBAtsvr1UDwXQ&quot;, &quot;y&quot; =&gt; &quot;hPtgSkKH6DXzh18Ym_jh9bzcJir5mKp_skj9oKI5ydA&quot; }}}Notice how keys where chosen randomly from all the available keys. JOSEVirtualHSM always prefers keys on local node, when available. It's possible to specify how to sign using JOSEUtils.JWK.key_selector/0:iex&gt; JOSEVirtualHSM.sign(%{&quot;hello&quot; =&gt; &quot;world&quot;}, alg: [&quot;ES256&quot;, &quot;ES384&quot;, &quot;ES512&quot;]) {:ok, {&quot;eyJhbGciOiJFUzI1NiJ9.eyJoZWxsbyI6IndvcmxkIn0.ooZ8pRuhp20K8s7k0xkNGCb47nE8sW_JrjHtsb_w5PEFFGR1F7wysJGfg2tTU7kT0QzQQEeWUg0FJgkqsowbTw&quot;, %{ &quot;crv&quot; =&gt; &quot;P-256&quot;, &quot;kid&quot; =&gt; &quot;SiuAFPXstUhUzhmc__1mybX1ZJcJ6F2llEeb-LaAjIo&quot;, &quot;kty&quot; =&gt; &quot;EC&quot;, &quot;use&quot; =&gt; &quot;sig&quot;, &quot;x&quot; =&gt; &quot;2PXy4aIbWUHzkRksSITO1ws9Y1AI14fBAtsvr1UDwXQ&quot;, &quot;y&quot; =&gt; &quot;hPtgSkKH6DXzh18Ym_jh9bzcJir5mKp_skj9oKI5ydA&quot; }}} iex&gt; JOSEVirtualHSM.sign(%{&quot;hello&quot; =&gt; &quot;world&quot;}, kty: &quot;OKP&quot;) {:ok, {&quot;eyJhbGciOiJFZERTQSJ9.eyJoZWxsbyI6IndvcmxkIn0.WVRgyl4Pen0nieJF7cmGXQnkOocP4B6i78VgkKxcu_-gADSIM5Cg_mL2T-cU1ZY1ib91bQnHALdNoXqVSi66DQ&quot;, %{ &quot;crv&quot; =&gt; &quot;Ed25519&quot;, &quot;kid&quot; =&gt; &quot;Hq3_i8UWJ1FqokUqTQRDLw4GvvBQCKiMjSoQ4Ng6CY0&quot;, &quot;kty&quot; =&gt; &quot;OKP&quot;, &quot;use&quot; =&gt; &quot;sig&quot;, &quot;x&quot; =&gt; &quot;XxHceRoVym7hsb5W-T2RqTzgoz_DEmCZKHBjy6MWsZA&quot; }}}DecryptionWith RSA:iex&gt; jwk_pub = JOSEVirtualHSM.public_keys() |&gt; Enum.find(&amp;(&amp;1[&quot;kty&quot;] == &quot;RSA&quot; and &amp;1[&quot;use&quot;] == &quot;enc&quot;)) %{ &quot;e&quot; =&gt; &quot;AQAB&quot;, &quot;kid&quot; =&gt; &quot;szhiyrpeKBtQOr6cSEj3TbJ87vqvvGuk3Is6cPBYNm0&quot;, &quot;kty&quot; =&gt; &quot;RSA&quot;, &quot;n&quot; =&gt; &quot;5GX4GERxJ2rV-w5T2G00D3-HLEriXjriL-w7TkCB9H8zhiljHH0SxmbxBMT5HksJMWQyiDZEKp6ilrZCjsvOAJCpvh0SrPnIRzu95Wt1VlGOlp0C2BnL0wuPnkrUHbGZAzE-ux4ISpw9LqTi6KlL1dWQei6-_ihs0E37iTpFJy2EbEVXG6ydsH0FnoJv0_dgf3P4Yy8kIoNx5f4czLSWhK-psoPVKxxAN3mlY7iRGQHxOdgEyrsANj8uSQehzO87T5IVmMDtoBBx6PUn9awDW5emoU_mfXy3hlR3S67pjbjfNA5A3QZBs39-hCU92EtA7CS0IQ_rvvAfvlLV3T-tjQ&quot;, &quot;use&quot; =&gt; &quot;enc&quot; } iex&gt; jwe = JOSEUtils.JWE.encrypt!(%{&quot;very&quot; =&gt; &quot;secret&quot;}, jwk_pub, &quot;RSA-OAEP&quot;, &quot;A128GCM&quot;) &quot;eyJhbGciOiJSU0EtT0FFUCIsImVuYyI6IkExMjhHQ00ifQ.0odG-8i5DL-SB1h4_DeGbavEZhACbVKqvnz2MCoSUyCW84U7ejqn2HqLh8Te03_yIlR9jC8raJ4OI75fbsK9bKrSf_RubJIYjVto0GaBIJzREujjS2fVACe5UUPQ9lVkYplXiT-wqm3wvtX9GkaBz4FL-fmftgtdW9zdYC9U2D_AfFG5hhO4BnAUaI7x1wDdnVMCPjbg5B21x6IPGSma0H6YgCyBf26BRIuNNRbaly89CAam3oqzTn3t0UrDb-Hrx8jEC4a9RxmL44RIdFVAjijcWLjorSd8qq8qGrDa7gpcFEGAYrX7U5XDawjyJnWzWD1g-LDn6H0IbAn5LEorEA.rTMjuaYevaacZbzt.6t7IpuvqFe2nt94httLzpjk.Cc5UcgwZBhkuUFsDeKpQBA&quot; iex&gt; JOSEVirtualHSM.decrypt(jwe) {:ok, {&quot;{\\&quot;very\\&quot;:\\&quot;secret\\&quot;}&quot;, %{ &quot;e&quot; =&gt; &quot;AQAB&quot;, &quot;kid&quot; =&gt; &quot;szhiyrpeKBtQOr6cSEj3TbJ87vqvvGuk3Is6cPBYNm0&quot;, &quot;kty&quot; =&gt; &quot;RSA&quot;, &quot;n&quot; =&gt; &quot;5GX4GERxJ2rV-w5T2G00D3-HLEriXjriL-w7TkCB9H8zhiljHH0SxmbxBMT5HksJMWQyiDZEKp6ilrZCjsvOAJCpvh0SrPnIRzu95Wt1VlGOlp0C2BnL0wuPnkrUHbGZAzE-ux4ISpw9LqTi6KlL1dWQei6-_ihs0E37iTpFJy2EbEVXG6ydsH0FnoJv0_dgf3P4Yy8kIoNx5f4czLSWhK-psoPVKxxAN3mlY7iRGQHxOdgEyrsANj8uSQehzO87T5IVmMDtoBBx6PUn9awDW5emoU_mfXy3hlR3S67pjbjfNA5A3QZBs39-hCU92EtA7CS0IQ_rvvAfvlLV3T-tjQ&quot;, &quot;use&quot; =&gt; &quot;enc&quot; }}}With ECDH-ES:iex&gt; jwk_pub = JOSEVirtualHSM.public_keys() |&gt; Enum.find(&amp;(&amp;1[&quot;kty&quot;] == &quot;EC&quot; and &amp;1[&quot;use&quot;] == &quot;enc&quot;)) %{ &quot;crv&quot; =&gt; &quot;P-256&quot;, &quot;kid&quot; =&gt; &quot;ltu_BZFFssJhqlTdKvf3VWu7z9dFKhwFxXSx8Q-bpw4&quot;, &quot;kty&quot; =&gt; &quot;EC&quot;, &quot;use&quot; =&gt; &quot;enc&quot;, &quot;x&quot; =&gt; &quot;jopq4PgS4w9721MwJppxw7niV-1zqgtBd-JeVWPuBcU&quot;, &quot;y&quot; =&gt; &quot;Eo1xbm0g5AsB8GSiXKHRynXH2OwRcMO9i-6PTi-k-GE&quot; } iex&gt; my_jwk_priv = JOSE.JWK.generate_key({:ec, &quot;P-256&quot;}) |&gt; JOSE.JWK.to_map() |&gt; elem(1) %{ &quot;crv&quot; =&gt; &quot;P-256&quot;, &quot;d&quot; =&gt; &quot;TsfNgJq_UEWdf0rqp2W5OQJQMbtANMMWwguNO4VrZkM&quot;, &quot;kty&quot; =&gt; &quot;EC&quot;, &quot;x&quot; =&gt; &quot;UIZ5br7q2li5NzcZePOiK4Wi3jV4xATVT4Yie8xMRT8&quot;, &quot;y&quot; =&gt; &quot;eiLF2EUWFbPX2MTchz_h-VbiEjnJ9koB-6kVqWF3kBo&quot; } iex&gt; jwe = JOSEUtils.JWE.encrypt!(%{&quot;very&quot; =&gt; &quot;secret&quot;}, {jwk_pub, my_jwk_priv}, &quot;ECDH-ES&quot;, &quot;A128GCM&quot;) &quot;eyJhbGciOiJFQ0RILUVTIiwiZW5jIjoiQTEyOEdDTSIsImVwayI6eyJjcnYiOiJQLTI1NiIsImt0eSI6IkVDIiwieCI6IlVJWjVicjdxMmxpNU56Y1plUE9pSzRXaTNqVjR4QVRWVDRZaWU4eE1SVDgiLCJ5IjoiZWlMRjJFVVdGYlBYMk1UY2h6X2gtVmJpRWpuSjlrb0ItNmtWcVdGM2tCbyJ9fQ..16AhXI2qu9cw7A6e.dG_TaBdpAJHgR962LxThdWo.uBtZ3N55sztIRgCFwzC5hw&quot; iex&gt; JOSEVirtualHSM.decrypt(jwe) {:ok, {&quot;{\\&quot;very\\&quot;:\\&quot;secret\\&quot;}&quot;, %{ &quot;crv&quot; =&gt; &quot;P-256&quot;, &quot;kid&quot; =&gt; &quot;ltu_BZFFssJhqlTdKvf3VWu7z9dFKhwFxXSx8Q-bpw4&quot;, &quot;kty&quot; =&gt; &quot;EC&quot;, &quot;use&quot; =&gt; &quot;enc&quot;, &quot;x&quot; =&gt; &quot;jopq4PgS4w9721MwJppxw7niV-1zqgtBd-JeVWPuBcU&quot;, &quot;y&quot; =&gt; &quot;Eo1xbm0g5AsB8GSiXKHRynXH2OwRcMO9i-6PTi-k-GE&quot; }}}ClusteringThe JOSEVirtualHSM of the current node listens to other JOSEVirtualHSM on joining and leaving of other nodes, and registers their public keys and deletes them when needed.This is based on BEAM distribution. Other distribution methods (such as using Redis as an intermediary) are not supported.ArchitectureEach node runs its own instance of JOSEVirtualHSM, which is a GenServer. This GenServer has the following roles:on startup, it loads the keys from the key specificationit stores local private keys in a private ETSit listens for joining and leaving nodes to gain knowledge of available keysWhen an operation is requested for a local key, the local instance of JOSEVirtualHSM launches a worker process and sends it the required private keys to perform the signing or decryption operation. This process is in charge of:performing the signing or decryption operationanswer to the original processThe JOSEVirtualHSM instance keeps track of the launched process and responds with an error to the calling process if the worker process died in an abnormal manner.The number of worker processes is not limited. No queueing or pooling method is implemented. As a consequence, a server could become unresponsive and overwhelmed should too many signing or decryption requests arrive at the same time. Any PR implementing it is welcome :)","ref":"JOSEVirtualHSM.html","title":"JOSEVirtualHSM","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"JOSEVirtualHSM.html#child_spec/1","title":"JOSEVirtualHSM.child_spec/1","type":"function"},{"doc":"Decrypts a JWE encrypted with a public key of JOSEVirtualHSMAs the encryption key can be located on any node running JOSEVirtualHSM in the cluster, this function:retains only the keys that could have been used for encryptiontries decrypting the JWE sequentially on each possible node (it does not try to decrypt in parallel for performance reason: this would overload the JOSEVirtualHSM instances)For instance:JOSEVirtualHSM.decrypt(jwe)This function determines automatically the algorithms in use from the JWE header. The second parameter may be used to further select specific keys:JOSEVirtualHSM.decrypt(jwe, kid: &quot;iBRaf9ugUtDUe2i2cAY9i4N315O6f_cSNeEEDi9wuQY&quot;)","ref":"JOSEVirtualHSM.html#decrypt/3","title":"JOSEVirtualHSM.decrypt/3","type":"function"},{"doc":"Return the registered public keysOptions:local_only: when set to true, only returns the local keys, not those registered from other nodes. Defaults to false","ref":"JOSEVirtualHSM.html#public_keys/1","title":"JOSEVirtualHSM.public_keys/1","type":"function"},{"doc":"Signs a message with one of the available signing keysIf the payload is a string, it is signed as is. Otherwise, it is encoded to a string using Jason.encode/1. Example:JOSEVirtualHSM.sign(%{&quot;Hello&quot; =&gt; &quot;Tomo&quot;})The second parameter can be used to further specify which type of key to use:JOSEVirtualHSM.sign(%{&quot;Hello&quot; =&gt; &quot;Tomo&quot;}, kty: &quot;RSA&quot;) JOSEVirtualHSM.sign(%{&quot;Hello&quot; =&gt; &quot;Tomo&quot;}, crv: &quot;P-256&quot;) JOSEVirtualHSM.sign(%{&quot;Hello&quot; =&gt; &quot;Tomo&quot;}, alg: [&quot;EdDSA&quot;, &quot;RS512&quot;])and can be used to use a specific key as well:JOSEVirtualHSM.sign(%{&quot;Hello&quot; =&gt; &quot;Tomo&quot;}, kid: &quot;&quot;wVX9XFHbv9ihewikZ2h-4FuwMZJIONu3n_0AdPFxy2Q&quot;&quot;)When more than one key is available for signing, one is chosen randomly. Don't be surprised if signing returns JWSes signed with different algorithms!","ref":"JOSEVirtualHSM.html#sign/3","title":"JOSEVirtualHSM.sign/3","type":"function"},{"doc":"Starts a supervised JOSE virtual HSMOptions:delete_on_load: deletes the file or environment option of a key after loading it. Boolean, defaults to true:keys: the list of keys to load. See key_load_specs/0 for the different methods to load keys","ref":"JOSEVirtualHSM.html#start_link/1","title":"JOSEVirtualHSM.start_link/1","type":"function"},{"doc":"","ref":"JOSEVirtualHSM.html#t:key_fields/0","title":"JOSEVirtualHSM.key_fields/0","type":"type"},{"doc":"","ref":"JOSEVirtualHSM.html#t:key_load_spec/0","title":"JOSEVirtualHSM.key_load_spec/0","type":"type"},{"doc":"","ref":"JOSEVirtualHSM.html#t:key_load_specs/0","title":"JOSEVirtualHSM.key_load_specs/0","type":"type"},{"doc":"","ref":"JOSEVirtualHSM.DecryptionError.html","title":"JOSEVirtualHSM.DecryptionError","type":"exception"},{"doc":"","ref":"JOSEVirtualHSM.NoSuitableAlgFoundError.html","title":"JOSEVirtualHSM.NoSuitableAlgFoundError","type":"exception"},{"doc":"","ref":"JOSEVirtualHSM.NoSuitableKeyFoundError.html","title":"JOSEVirtualHSM.NoSuitableKeyFoundError","type":"exception"},{"doc":"","ref":"JOSEVirtualHSM.WorkerError.html","title":"JOSEVirtualHSM.WorkerError","type":"exception"},{"doc":"JOSEVirtualHSMVirtual JOSE HSM for signing JWSes and decrypting JWEs","ref":"readme.html","title":"JOSEVirtualHSM","type":"extras"},{"doc":"def deps do [ {:jose_virtual_hsm, &quot;~&gt; 0.1.0&quot;} ] end","ref":"readme.html#installation","title":"JOSEVirtualHSM - Installation","type":"extras"},{"doc":"It is a virtual HSM in the sense that keys private keys for signing and decrypting are not available to other processes, and are particularly protected against leaking:there are stored in a private ETSprocesses dealing with these keys are marked as sensitivekeys loaded from the disk or the environment can be deleted after loading (ideal for container deployment)Other features include:keys can be generated automatically given a specification, so that there no secret to handle during deploymentit is automatically clusterized: any node can sign a JWS or decrypt a JWE with any key in the cluster. Nodes don't share keys (they can't) but can work with each other in a transparent fashionkey ID is automatically generated using RFC7638 - JSON Web Key (JWK) Thumbprinthowever, note that due to a limitation in the underlying JOSE library, JWSes do not include the kid in their header","ref":"readme.html#description","title":"JOSEVirtualHSM - Description","type":"extras"},{"doc":"JOSEVirtualHSM is a GenServer that must be launched in a supervised manner at application startup. In your app/application.ex file, add:children = [ JOSEVirtualHSM ]orchildren = [ {JOSEVirtualHSM, opts...} ]where opts is a Keyword to the list of children.","ref":"readme.html#launching-josevirtualhsm","title":"JOSEVirtualHSM - Launching JOSEVirtualHSM","type":"extras"},{"doc":":delete_on_load: when loading a private key from a file or the environment, this options, when set to true, deletes the key after loading. Defaults to true:keys: the list of keys to load. See t:key_load_specs/0 for the different methods to load keys","ref":"readme.html#options","title":"JOSEVirtualHSM - Options","type":"extras"},{"doc":"The key specification can also be retrieved from the environment options:config/config.exsconfig :jose_virtual_hsm, :keys, [ {:auto_gen, {:ec, &quot;P-256&quot;}, %{&quot;use&quot; =&gt; &quot;sig&quot;}}, {:auto_gen, {:rsa, 2048}, %{&quot;use&quot; =&gt; &quot;sig&quot;}}, {:auto_gen, {:okp, :Ed25519}, %{&quot;use&quot; =&gt; &quot;sig&quot;}}, {:auto_gen, {:ec, &quot;P-256&quot;}, %{&quot;use&quot; =&gt; &quot;enc&quot;}}, {:auto_gen, {:rsa, 2048}, %{&quot;use&quot; =&gt; &quot;enc&quot;}}, {:auto_gen, {:okp, :X25519}, %{&quot;use&quot; =&gt; &quot;enc&quot;}} ]This key specification is used i nthe following examples.","ref":"readme.html#environment-options","title":"JOSEVirtualHSM - Environment options","type":"extras"},{"doc":"Retrieving public keysiex&gt; JOSEVirtualHSM.public_keys() [ %{ &quot;crv&quot; =&gt; &quot;X25519&quot;, &quot;kid&quot; =&gt; &quot;NqYw6_wlorTvDqae3HaI79i_k_Q61l0jESQNvgT0Ku4&quot;, &quot;kty&quot; =&gt; &quot;OKP&quot;, &quot;use&quot; =&gt; &quot;enc&quot;, &quot;x&quot; =&gt; &quot;lY2nopV03NTsSqCVgfyr_VNjTBkUhGHcHjIHJNrlaKQ&quot; }, %{ &quot;crv&quot; =&gt; &quot;Ed25519&quot;, &quot;kid&quot; =&gt; &quot;Hq3_i8UWJ1FqokUqTQRDLw4GvvBQCKiMjSoQ4Ng6CY0&quot;, &quot;kty&quot; =&gt; &quot;OKP&quot;, &quot;use&quot; =&gt; &quot;sig&quot;, &quot;x&quot; =&gt; &quot;XxHceRoVym7hsb5W-T2RqTzgoz_DEmCZKHBjy6MWsZA&quot; }, %{ &quot;e&quot; =&gt; &quot;AQAB&quot;, &quot;kid&quot; =&gt; &quot;5A5Z3JxpYNO4pqbfC4wSFUk2cpkcAxwZsH0yev3zXpk&quot;, &quot;kty&quot; =&gt; &quot;RSA&quot;, &quot;n&quot; =&gt; &quot;7Rwb2l4ORycxCPAMK2B_p1FqKqrBpmcjklqazucAiJtNPtY2n-yEziD05-urwutIN2-wfaKIGg51-8KIQN5x_PTXUxje2oK3GOHHWaSWGpd1kJVEe-owSKGQxoga5rQDTk4j3MMA0brbgoJM2v32lKiv5CgV6E-wgCXb8QlrvIpwhnIN9CPEHuxo9Izpw8WqIj4d8Uu7LohxUM0eFfBkdbmgt5xL4Xm5MV6eDRhYq9agRLGNbBIHK2T5Xyq6-YB5URtWCeizA8hongk6nZAzy19wvz88pj4CsBy73UuP0jdT-wlGGvTpGx9AEFLv1p_RXzVgfZMGn2z3Q8Mhf0mxVQ&quot;, &quot;use&quot; =&gt; &quot;sig&quot; }, %{ &quot;e&quot; =&gt; &quot;AQAB&quot;, &quot;kid&quot; =&gt; &quot;szhiyrpeKBtQOr6cSEj3TbJ87vqvvGuk3Is6cPBYNm0&quot;, &quot;kty&quot; =&gt; &quot;RSA&quot;, &quot;n&quot; =&gt; &quot;5GX4GERxJ2rV-w5T2G00D3-HLEriXjriL-w7TkCB9H8zhiljHH0SxmbxBMT5HksJMWQyiDZEKp6ilrZCjsvOAJCpvh0SrPnIRzu95Wt1VlGOlp0C2BnL0wuPnkrUHbGZAzE-ux4ISpw9LqTi6KlL1dWQei6-_ihs0E37iTpFJy2EbEVXG6ydsH0FnoJv0_dgf3P4Yy8kIoNx5f4czLSWhK-psoPVKxxAN3mlY7iRGQHxOdgEyrsANj8uSQehzO87T5IVmMDtoBBx6PUn9awDW5emoU_mfXy3hlR3S67pjbjfNA5A3QZBs39-hCU92EtA7CS0IQ_rvvAfvlLV3T-tjQ&quot;, &quot;use&quot; =&gt; &quot;enc&quot; }, %{ &quot;crv&quot; =&gt; &quot;P-256&quot;, &quot;kid&quot; =&gt; &quot;ltu_BZFFssJhqlTdKvf3VWu7z9dFKhwFxXSx8Q-bpw4&quot;, &quot;kty&quot; =&gt; &quot;EC&quot;, &quot;use&quot; =&gt; &quot;enc&quot;, &quot;x&quot; =&gt; &quot;jopq4PgS4w9721MwJppxw7niV-1zqgtBd-JeVWPuBcU&quot;, &quot;y&quot; =&gt; &quot;Eo1xbm0g5AsB8GSiXKHRynXH2OwRcMO9i-6PTi-k-GE&quot; }, %{ &quot;crv&quot; =&gt; &quot;P-256&quot;, &quot;kid&quot; =&gt; &quot;SiuAFPXstUhUzhmc__1mybX1ZJcJ6F2llEeb-LaAjIo&quot;, &quot;kty&quot; =&gt; &quot;EC&quot;, &quot;use&quot; =&gt; &quot;sig&quot;, &quot;x&quot; =&gt; &quot;2PXy4aIbWUHzkRksSITO1ws9Y1AI14fBAtsvr1UDwXQ&quot;, &quot;y&quot; =&gt; &quot;hPtgSkKH6DXzh18Ym_jh9bzcJir5mKp_skj9oKI5ydA&quot; } ]These public keys can obviously be shared with third parties. They can be used:to verify signature of a JWS signed by JOSEVirtualHSMto encrypt a JWE to be sent to the server using JOSEVirtualHSMJOSEVirtualHSM doesn't support JWS verification and JWE encryption. For that, use JOSE or JOSEUtils instead.Signing:iex&gt; JOSEVirtualHSM.sign(%{&quot;hello&quot; =&gt; &quot;world&quot;}) {:ok, {&quot;eyJhbGciOiJSUzI1NiJ9.eyJoZWxsbyI6IndvcmxkIn0.nFP2GBJdsKzgUMR7g55pMmtNckXB9F9C83jhfAW0qOake7AmpZb3eLZhGi3OrTB7CRI2x9MHtA1qQMdOY0u8R_VovYfv5fGLVRJLe8uICGIq1NojO_66lMMoxmtMxIhVcX1FZfWR9Z_Ez4KGVm4eJvTuO33ds115Ik8Vh3aGFBorW74rYqjYZPgEHyjO4RqbzexBodq-z5rGOqAvFgz9C6X_xkMwiI6mNI4XIQ-5jzLPKMP5t94QwJGZ4EEc9QyFbNqmh2OlUaY0NTthP6MAzler7K5oz2S_6mQvt6K4Fmk1C-HIR3nad_s_z-PLvj6tEJnmIiEcFHTxfRcceUQ_QA&quot;, %{ &quot;e&quot; =&gt; &quot;AQAB&quot;, &quot;kid&quot; =&gt; &quot;5A5Z3JxpYNO4pqbfC4wSFUk2cpkcAxwZsH0yev3zXpk&quot;, &quot;kty&quot; =&gt; &quot;RSA&quot;, &quot;n&quot; =&gt; &quot;7Rwb2l4ORycxCPAMK2B_p1FqKqrBpmcjklqazucAiJtNPtY2n-yEziD05-urwutIN2-wfaKIGg51-8KIQN5x_PTXUxje2oK3GOHHWaSWGpd1kJVEe-owSKGQxoga5rQDTk4j3MMA0brbgoJM2v32lKiv5CgV6E-wgCXb8QlrvIpwhnIN9CPEHuxo9Izpw8WqIj4d8Uu7LohxUM0eFfBkdbmgt5xL4Xm5MV6eDRhYq9agRLGNbBIHK2T5Xyq6-YB5URtWCeizA8hongk6nZAzy19wvz88pj4CsBy73UuP0jdT-wlGGvTpGx9AEFLv1p_RXzVgfZMGn2z3Q8Mhf0mxVQ&quot;, &quot;use&quot; =&gt; &quot;sig&quot; }}} iex&gt; JOSEVirtualHSM.sign(%{&quot;hello&quot; =&gt; &quot;world&quot;}) {:ok, {&quot;eyJhbGciOiJFZERTQSJ9.eyJoZWxsbyI6IndvcmxkIn0.WVRgyl4Pen0nieJF7cmGXQnkOocP4B6i78VgkKxcu_-gADSIM5Cg_mL2T-cU1ZY1ib91bQnHALdNoXqVSi66DQ&quot;, %{ &quot;crv&quot; =&gt; &quot;Ed25519&quot;, &quot;kid&quot; =&gt; &quot;Hq3_i8UWJ1FqokUqTQRDLw4GvvBQCKiMjSoQ4Ng6CY0&quot;, &quot;kty&quot; =&gt; &quot;OKP&quot;, &quot;use&quot; =&gt; &quot;sig&quot;, &quot;x&quot; =&gt; &quot;XxHceRoVym7hsb5W-T2RqTzgoz_DEmCZKHBjy6MWsZA&quot; }}} iex&gt; JOSEVirtualHSM.sign(%{&quot;hello&quot; =&gt; &quot;world&quot;}) {:ok, {&quot;eyJhbGciOiJFZERTQSJ9.eyJoZWxsbyI6IndvcmxkIn0.WVRgyl4Pen0nieJF7cmGXQnkOocP4B6i78VgkKxcu_-gADSIM5Cg_mL2T-cU1ZY1ib91bQnHALdNoXqVSi66DQ&quot;, %{ &quot;crv&quot; =&gt; &quot;Ed25519&quot;, &quot;kid&quot; =&gt; &quot;Hq3_i8UWJ1FqokUqTQRDLw4GvvBQCKiMjSoQ4Ng6CY0&quot;, &quot;kty&quot; =&gt; &quot;OKP&quot;, &quot;use&quot; =&gt; &quot;sig&quot;, &quot;x&quot; =&gt; &quot;XxHceRoVym7hsb5W-T2RqTzgoz_DEmCZKHBjy6MWsZA&quot; }}} iex&gt; JOSEVirtualHSM.sign(%{&quot;hello&quot; =&gt; &quot;world&quot;}) {:ok, {&quot;eyJhbGciOiJFUzI1NiJ9.eyJoZWxsbyI6IndvcmxkIn0.1viHUsVOseF1eJ0nZAOXbo0RfHGP5H1U8lfV9qLijf4EnDbaPI7NkRdFQIHvbYVTYakm0dHdF2YPlNfKOrGMbg&quot;, %{ &quot;crv&quot; =&gt; &quot;P-256&quot;, &quot;kid&quot; =&gt; &quot;SiuAFPXstUhUzhmc__1mybX1ZJcJ6F2llEeb-LaAjIo&quot;, &quot;kty&quot; =&gt; &quot;EC&quot;, &quot;use&quot; =&gt; &quot;sig&quot;, &quot;x&quot; =&gt; &quot;2PXy4aIbWUHzkRksSITO1ws9Y1AI14fBAtsvr1UDwXQ&quot;, &quot;y&quot; =&gt; &quot;hPtgSkKH6DXzh18Ym_jh9bzcJir5mKp_skj9oKI5ydA&quot; }}}Notice how keys where chosen randomly from all the available keys. JOSEVirtualHSM always prefers keys on local node, when available. It's possible to specify how to sign using JOSEUtils.JWK.key_selector/0:iex&gt; JOSEVirtualHSM.sign(%{&quot;hello&quot; =&gt; &quot;world&quot;}, alg: [&quot;ES256&quot;, &quot;ES384&quot;, &quot;ES512&quot;]) {:ok, {&quot;eyJhbGciOiJFUzI1NiJ9.eyJoZWxsbyI6IndvcmxkIn0.ooZ8pRuhp20K8s7k0xkNGCb47nE8sW_JrjHtsb_w5PEFFGR1F7wysJGfg2tTU7kT0QzQQEeWUg0FJgkqsowbTw&quot;, %{ &quot;crv&quot; =&gt; &quot;P-256&quot;, &quot;kid&quot; =&gt; &quot;SiuAFPXstUhUzhmc__1mybX1ZJcJ6F2llEeb-LaAjIo&quot;, &quot;kty&quot; =&gt; &quot;EC&quot;, &quot;use&quot; =&gt; &quot;sig&quot;, &quot;x&quot; =&gt; &quot;2PXy4aIbWUHzkRksSITO1ws9Y1AI14fBAtsvr1UDwXQ&quot;, &quot;y&quot; =&gt; &quot;hPtgSkKH6DXzh18Ym_jh9bzcJir5mKp_skj9oKI5ydA&quot; }}} iex&gt; JOSEVirtualHSM.sign(%{&quot;hello&quot; =&gt; &quot;world&quot;}, kty: &quot;OKP&quot;) {:ok, {&quot;eyJhbGciOiJFZERTQSJ9.eyJoZWxsbyI6IndvcmxkIn0.WVRgyl4Pen0nieJF7cmGXQnkOocP4B6i78VgkKxcu_-gADSIM5Cg_mL2T-cU1ZY1ib91bQnHALdNoXqVSi66DQ&quot;, %{ &quot;crv&quot; =&gt; &quot;Ed25519&quot;, &quot;kid&quot; =&gt; &quot;Hq3_i8UWJ1FqokUqTQRDLw4GvvBQCKiMjSoQ4Ng6CY0&quot;, &quot;kty&quot; =&gt; &quot;OKP&quot;, &quot;use&quot; =&gt; &quot;sig&quot;, &quot;x&quot; =&gt; &quot;XxHceRoVym7hsb5W-T2RqTzgoz_DEmCZKHBjy6MWsZA&quot; }}}DecryptionWith RSA:iex&gt; jwk_pub = JOSEVirtualHSM.public_keys() |&gt; Enum.find(&amp;(&amp;1[&quot;kty&quot;] == &quot;RSA&quot; and &amp;1[&quot;use&quot;] == &quot;enc&quot;)) %{ &quot;e&quot; =&gt; &quot;AQAB&quot;, &quot;kid&quot; =&gt; &quot;szhiyrpeKBtQOr6cSEj3TbJ87vqvvGuk3Is6cPBYNm0&quot;, &quot;kty&quot; =&gt; &quot;RSA&quot;, &quot;n&quot; =&gt; &quot;5GX4GERxJ2rV-w5T2G00D3-HLEriXjriL-w7TkCB9H8zhiljHH0SxmbxBMT5HksJMWQyiDZEKp6ilrZCjsvOAJCpvh0SrPnIRzu95Wt1VlGOlp0C2BnL0wuPnkrUHbGZAzE-ux4ISpw9LqTi6KlL1dWQei6-_ihs0E37iTpFJy2EbEVXG6ydsH0FnoJv0_dgf3P4Yy8kIoNx5f4czLSWhK-psoPVKxxAN3mlY7iRGQHxOdgEyrsANj8uSQehzO87T5IVmMDtoBBx6PUn9awDW5emoU_mfXy3hlR3S67pjbjfNA5A3QZBs39-hCU92EtA7CS0IQ_rvvAfvlLV3T-tjQ&quot;, &quot;use&quot; =&gt; &quot;enc&quot; } iex&gt; jwe = JOSEUtils.JWE.encrypt!(%{&quot;very&quot; =&gt; &quot;secret&quot;}, jwk_pub, &quot;RSA-OAEP&quot;, &quot;A128GCM&quot;) &quot;eyJhbGciOiJSU0EtT0FFUCIsImVuYyI6IkExMjhHQ00ifQ.0odG-8i5DL-SB1h4_DeGbavEZhACbVKqvnz2MCoSUyCW84U7ejqn2HqLh8Te03_yIlR9jC8raJ4OI75fbsK9bKrSf_RubJIYjVto0GaBIJzREujjS2fVACe5UUPQ9lVkYplXiT-wqm3wvtX9GkaBz4FL-fmftgtdW9zdYC9U2D_AfFG5hhO4BnAUaI7x1wDdnVMCPjbg5B21x6IPGSma0H6YgCyBf26BRIuNNRbaly89CAam3oqzTn3t0UrDb-Hrx8jEC4a9RxmL44RIdFVAjijcWLjorSd8qq8qGrDa7gpcFEGAYrX7U5XDawjyJnWzWD1g-LDn6H0IbAn5LEorEA.rTMjuaYevaacZbzt.6t7IpuvqFe2nt94httLzpjk.Cc5UcgwZBhkuUFsDeKpQBA&quot; iex&gt; JOSEVirtualHSM.decrypt(jwe) {:ok, {&quot;{\\\\&quot;very\\\\&quot;:\\\\&quot;secret\\\\&quot;}&quot;, %{ &quot;e&quot; =&gt; &quot;AQAB&quot;, &quot;kid&quot; =&gt; &quot;szhiyrpeKBtQOr6cSEj3TbJ87vqvvGuk3Is6cPBYNm0&quot;, &quot;kty&quot; =&gt; &quot;RSA&quot;, &quot;n&quot; =&gt; &quot;5GX4GERxJ2rV-w5T2G00D3-HLEriXjriL-w7TkCB9H8zhiljHH0SxmbxBMT5HksJMWQyiDZEKp6ilrZCjsvOAJCpvh0SrPnIRzu95Wt1VlGOlp0C2BnL0wuPnkrUHbGZAzE-ux4ISpw9LqTi6KlL1dWQei6-_ihs0E37iTpFJy2EbEVXG6ydsH0FnoJv0_dgf3P4Yy8kIoNx5f4czLSWhK-psoPVKxxAN3mlY7iRGQHxOdgEyrsANj8uSQehzO87T5IVmMDtoBBx6PUn9awDW5emoU_mfXy3hlR3S67pjbjfNA5A3QZBs39-hCU92EtA7CS0IQ_rvvAfvlLV3T-tjQ&quot;, &quot;use&quot; =&gt; &quot;enc&quot; }}}With ECDH-ES:iex&gt; jwk_pub = JOSEVirtualHSM.public_keys() |&gt; Enum.find(&amp;(&amp;1[&quot;kty&quot;] == &quot;EC&quot; and &amp;1[&quot;use&quot;] == &quot;enc&quot;)) %{ &quot;crv&quot; =&gt; &quot;P-256&quot;, &quot;kid&quot; =&gt; &quot;ltu_BZFFssJhqlTdKvf3VWu7z9dFKhwFxXSx8Q-bpw4&quot;, &quot;kty&quot; =&gt; &quot;EC&quot;, &quot;use&quot; =&gt; &quot;enc&quot;, &quot;x&quot; =&gt; &quot;jopq4PgS4w9721MwJppxw7niV-1zqgtBd-JeVWPuBcU&quot;, &quot;y&quot; =&gt; &quot;Eo1xbm0g5AsB8GSiXKHRynXH2OwRcMO9i-6PTi-k-GE&quot; } iex&gt; my_jwk_priv = JOSE.JWK.generate_key({:ec, &quot;P-256&quot;}) |&gt; JOSE.JWK.to_map() |&gt; elem(1) %{ &quot;crv&quot; =&gt; &quot;P-256&quot;, &quot;d&quot; =&gt; &quot;TsfNgJq_UEWdf0rqp2W5OQJQMbtANMMWwguNO4VrZkM&quot;, &quot;kty&quot; =&gt; &quot;EC&quot;, &quot;x&quot; =&gt; &quot;UIZ5br7q2li5NzcZePOiK4Wi3jV4xATVT4Yie8xMRT8&quot;, &quot;y&quot; =&gt; &quot;eiLF2EUWFbPX2MTchz_h-VbiEjnJ9koB-6kVqWF3kBo&quot; } iex&gt; jwe = JOSEUtils.JWE.encrypt!(%{&quot;very&quot; =&gt; &quot;secret&quot;}, {jwk_pub, my_jwk_priv}, &quot;ECDH-ES&quot;, &quot;A128GCM&quot;) &quot;eyJhbGciOiJFQ0RILUVTIiwiZW5jIjoiQTEyOEdDTSIsImVwayI6eyJjcnYiOiJQLTI1NiIsImt0eSI6IkVDIiwieCI6IlVJWjVicjdxMmxpNU56Y1plUE9pSzRXaTNqVjR4QVRWVDRZaWU4eE1SVDgiLCJ5IjoiZWlMRjJFVVdGYlBYMk1UY2h6X2gtVmJpRWpuSjlrb0ItNmtWcVdGM2tCbyJ9fQ..16AhXI2qu9cw7A6e.dG_TaBdpAJHgR962LxThdWo.uBtZ3N55sztIRgCFwzC5hw&quot; iex&gt; JOSEVirtualHSM.decrypt(jwe) {:ok, {&quot;{\\\\&quot;very\\\\&quot;:\\\\&quot;secret\\\\&quot;}&quot;, %{ &quot;crv&quot; =&gt; &quot;P-256&quot;, &quot;kid&quot; =&gt; &quot;ltu_BZFFssJhqlTdKvf3VWu7z9dFKhwFxXSx8Q-bpw4&quot;, &quot;kty&quot; =&gt; &quot;EC&quot;, &quot;use&quot; =&gt; &quot;enc&quot;, &quot;x&quot; =&gt; &quot;jopq4PgS4w9721MwJppxw7niV-1zqgtBd-JeVWPuBcU&quot;, &quot;y&quot; =&gt; &quot;Eo1xbm0g5AsB8GSiXKHRynXH2OwRcMO9i-6PTi-k-GE&quot; }}}","ref":"readme.html#example","title":"JOSEVirtualHSM - Example","type":"extras"},{"doc":"The JOSEVirtualHSM of the current node listens to other JOSEVirtualHSM on joining and leaving of other nodes, and registers their public keys and deletes them when needed.This is based on BEAM distribution. Other distribution methods (such as using Redis as an intermediary) are not supported.","ref":"readme.html#clustering","title":"JOSEVirtualHSM - Clustering","type":"extras"},{"doc":"Each node runs its own instance of JOSEVirtualHSM, which is a GenServer. This GenServer has the following roles:on startup, it loads the keys from the key specificationit stores local private keys in a private ETSit listens for joining and leaving nodes to gain knowledge of available keysWhen an operation is requested for a local key, the local instance of JOSEVirtualHSM launches a worker process and sends it the required private keys to perform the signing or decryption operation. This process is in charge of:performing the signing or decryption operationanswer to the original processThe JOSEVirtualHSM instance keeps track of the launched process and responds with an error to the calling process if the worker process died in an abnormal manner.The number of worker processes is not limited. No queueing or pooling method is implemented. As a consequence, a server could become unresponsive and overwhelmed should too many signing or decryption requests arrive at the same time. Any PR implementing it is welcome :)","ref":"readme.html#architecture","title":"JOSEVirtualHSM - Architecture","type":"extras"}]